<?php  // $Id: lib.php, 2008/2/29 Exp $

if (!isset($CFG->resource_framesize)) {
    set_config("resource_framesize", 130);
}

if (!isset($CFG->resource_websearch)) {
    set_config("resource_websearch", "http://google.com/");
}

if (!isset($CFG->resource_defaulturl)) {
    set_config("resource_defaulturl", "http://");
}

if (!isset($CFG->resource_filterexternalpages)) {
    set_config("resource_filterexternalpages", false);
}

if (!isset($CFG->resource_secretphrase)) {
    set_config("resource_secretphrase", random_string(20));
}

if (!isset($CFG->resource_popup)) {
    set_config("resource_popup", "");
}

if (!isset($CFG->resource_windowsettings)) {
    set_config("resource_windowsettings", "0");
}

if (!isset($CFG->resource_parametersettings)) {
    set_config("resource_parametersettings", "0");
}

if (!isset($CFG->resource_allowlocalfiles)) {
    set_config("resource_allowlocalfiles", "0");
}

if (!isset($CFG->resource_hide_repository)) {
    set_config("resource_hide_repository", "1");
}

if (!isset($CFG->resource_autofilerename)) {
    set_config("resource_autofilerename", "1");
}

if (!isset($CFG->resource_blockdeletingfile)) {
    set_config("resource_blockdeletingfile", "1");
}

define('RESOURCE_LOCALPATH', 'LOCALPATH');

$RESOURCE_WINDOW_OPTIONS = array('resizable', 'scrollbars', 'directories', 'location',
                                 'menubar', 'toolbar', 'status', 'height', 'width');

foreach ($RESOURCE_WINDOW_OPTIONS as $popupoption) {
    $popupoption = "resource_popup$popupoption";
    if (!isset($CFG->$popupoption)) {
        if ($popupoption == 'resource_popupheight') {
            set_config($popupoption, 450);
        } else if ($popupoption == 'resource_popupwidth') {
            set_config($popupoption, 620);
        } else {
            set_config($popupoption, 'checked');
        }
    }
}

/**
* resource_base is the base class for resource types
*
* This class provides all the functionality for a resource
*/

class resource_base {

var $cm;
var $course;
var $resource;


/**
* Constructor for the base resource class
*
* Constructor for the base resource class.
* If cmid is set create the cm, course, resource objects.
* and do some checks to make sure people can be here, and so on.
*
* @param cmid   integer, the current course module id - not set for new resources
*/
function resource_base($cmid=0) {

    global $CFG;
    global $course;   // Ugly hack, needed for course language ugly hack

    if ($cmid) {
        if (! $this->cm = get_coursemodule_from_id('resource', $cmid)) {
            error("Course Module ID was incorrect");
        }

        if (! $this->course = get_record("course", "id", $this->cm->course)) {
            error("Course is misconfigured");
        }

        $course = $this->course;  // Make it a global so we can see it later

        require_course_login($this->course, true, $this->cm);

        if (! $this->resource = get_record("resource", "id", $this->cm->instance)) {
            error("Resource ID was incorrect");
        }

        $this->strresource  = get_string("modulename", "resource");
        $this->strresources = get_string("modulenameplural", "resource");

        if ($this->course->category) {
            $this->navigation = "<a target=\"{$CFG->framename}\" href=\"$CFG->wwwroot/course/view.php?id={$this->course->id}\">{$this->course->shortname}</a> -> ".
                                "<a target=\"{$CFG->framename}\" href=\"index.php?id={$this->course->id}\">$this->strresources</a> ->";
        } else {
            $this->navigation = "<a target=\"{$CFG->framename}\" href=\"index.php?id={$this->course->id}\">$this->strresources</a> ->";
        }

        if (!$this->cm->visible and !has_capability('moodle/course:viewhiddenactivities', get_context_instance(CONTEXT_MODULE, $this->cm->id))) {
            $pagetitle = strip_tags($this->course->shortname.': '.$this->strresource);
            print_header($pagetitle, $this->course->fullname, "$this->navigation $this->strresource", "", "", true, '', navmenu($this->course, $this->cm));
            notice(get_string("activityiscurrentlyhidden"), "$CFG->wwwroot/course/view.php?id={$this->course->id}");
        }
    }
}

function setup2(&$form) {
    global $CFG, $usehtmleditor;

    if (! empty($form->course)) {
        if (! $this->course = get_record("course", "id", $form->course)) {
            error("Course is misconfigured");
        }
    }

    if (empty($form->name)) {
        $form->name = "";
    }
    if (empty($form->type)) {
        $form->type = "";
    }
    if (empty($form->summary)) {
        $form->summary = "";
    }
    if (empty($form->reference)) {
        $form->reference = "";
    }
    if (empty($form->alltext)) {
        $form->alltext = "";
    }
    if (empty($form->options)) {
        $form->options = "";
    }
    $nohtmleditorneeded = true;

    print_heading_with_help(get_string("resourcetype$form->type", 'resource'), $form->type, 'resource/type');

    include("$CFG->dirroot/mod/resource/type/common2.html");
}

function setup_end() {
    global $CFG;

    include("$CFG->dirroot/mod/resource/type/common_end.html");
}


}
?>
