<?php // $Id: mod2.php, 2008/02/29 13:02:53 thepurpleblob Exp $

//  Moves, adds, updates, duplicates or deletes modules in a course

    require("../config.php");
    require("lib.php");

    require_login();
    $sectionreturn = optional_param('sr', '', PARAM_INT);
    $add           = optional_param('add','', PARAM_ALPHA);
    $type          = optional_param('type', '', PARAM_ALPHA);
    $indent        = optional_param('indent', 0, PARAM_INT);
    $update        = optional_param('update', 0, PARAM_INT);
    $hide          = optional_param('hide', 0, PARAM_INT);
    $show          = optional_param('show', 0, PARAM_INT);
    $copy          = optional_param('copy', 0, PARAM_INT);
    $moveto        = optional_param('moveto', 0, PARAM_INT);
    $movetosection = optional_param('movetosection', 0, PARAM_INT);
    $delete        = optional_param('delete', 0, PARAM_INT);
    $course        = optional_param('course', 0, PARAM_INT);
    $groupmode     = optional_param('groupmode', -1, PARAM_INT);
    $duplicate     = optional_param('duplicate', 0, PARAM_INT);
    $cancel        = optional_param('cancel', 0, PARAM_BOOL);
    $cancelcopy    = optional_param('cancelcopy', 0, PARAM_BOOL);
    $treereturn    = optional_param('rncid', '', PARAM_INT);

    if (isset($SESSION->modform)) {   // Variables are stored in the session
        $mod = $SESSION->modform;
        unset($SESSION->modform);
    } else {
        $mod = (object)$_POST;
    }

    if ($cancel) {
        if (!empty($SESSION->returnpage)) {
            $return = $SESSION->returnpage;
            unset($SESSION->returnpage);
            redirect($return);
        } else {
            redirect("view.php?id=$mod->course#section-$sectionreturn");
        }
    }


    if (!empty($course) and confirm_sesskey()) {    // add or update form submitted
        if (empty($mod->coursemodule)) { //add
            if (! $course = get_record("course", "id", $mod->course)) {
                error("This course doesn't exist");
            }
            $mod->instance = '';
            $mod->coursemodule = '';
        } else { //delete and update
            if (! $cm = get_record("course_modules", "id", $mod->coursemodule)) {
                error("This course module doesn't exist");
            }

            if (! $course = get_record("course", "id", $cm->course)) {
                error("This course doesn't exist");
            }
            $mod->instance = $cm->instance;
            $mod->coursemodule = $cm->id;
        }

        require_login($course->id); // needed to setup proper $COURSE
        $context = get_context_instance(CONTEXT_COURSE, $course->id);
        require_capability('moodle/course:manageactivities', $context);
        
        $mod->course = $course->id;
        $mod->modulename = clean_param($mod->modulename, PARAM_SAFEDIR);  // For safety
        $modlib = "$CFG->dirroot/mod/$mod->modulename/lib.php";

        if (file_exists($modlib)) {
            include_once($modlib);
        } else {
            error("This module is missing important code! ($modlib)");
        }
        $addinstancefunction    = $mod->modulename."_add_instance";
        $updateinstancefunction = $mod->modulename."_update_instance";
        $deleteinstancefunction = $mod->modulename."_delete_instance";
        $moderr = "$CFG->dirroot/mod/$mod->modulename/moderr.html";

        switch ($mod->mode) {
            case "update":

                if (isset($mod->name)) {
                    if (trim($mod->name) == '') {
                        unset($mod->name);
                    }
                }

                $return = $updateinstancefunction($mod);
                if (!$return) {
                    if (file_exists($moderr)) {
                        $form = $mod;
                        include_once($moderr);
                        die;
                    }
                    error("Could not update the $mod->modulename", "view.php?id=$course->id");
                }
                if (is_string($return)) {
                    error($return, "view.php?id=$course->id");
                }

                if (isset($mod->visible)) {
                    set_coursemodule_visible($mod->coursemodule, $mod->visible);
                }

                if (isset($mod->groupmode)) {
                    set_coursemodule_groupmode($mod->coursemodule, $mod->groupmode);
                }

                if (isset($mod->redirect)) {
                    $SESSION->returnpage = $mod->redirecturl;
                } else {
                    $SESSION->returnpage = "$CFG->wwwroot/mod/$mod->modulename/view.php?id=$mod->coursemodule";
                }

                add_to_log($course->id, "course", "update mod",
                           "../mod/$mod->modulename/view.php?id=$mod->coursemodule",
                           "$mod->modulename $mod->instance");
                add_to_log($course->id, $mod->modulename, "update",
                           "view.php?id=$mod->coursemodule",
                           "$mod->instance", $mod->coursemodule);
                break;

            case "add":

                if (!course_allowed_module($course,$mod->modulename)) {
                    error("This module ($mod->modulename) has been disabled for this particular course");
                }

                if (!isset($mod->name) || trim($mod->name) == '') {
                    $mod->name = get_string("modulename", $mod->modulename);
                }

                $return = $addinstancefunction($mod);
                if (!$return) {
                    if (file_exists($moderr)) {
                        $form = $mod;
                        include_once($moderr);
                        die;
                    }
                    error("Could not add a new instance of $mod->modulename", "view.php?id=$course->id");
                }
                if (is_string($return)) {
                    error($return, "view.php?id=$course->id");
                }

                if (!isset($mod->groupmode)) { // to deal with pre-1.5 modules
                    $mod->groupmode = $course->groupmode;  /// Default groupmode the same as course
                }

                $mod->instance = $return;

                // course_modules and course_sections each contain a reference
                // to each other, so we have to update one of them twice.

                if (! $mod->coursemodule = add_course_module($mod) ) {
                    error("Could not add a new course module");
                }
                if (! $sectionid = add_mod_to_section($mod) ) {
                    error("Could not add the new course module to that section");
                }

                if (! set_field("course_modules", "section", $sectionid, "id", $mod->coursemodule)) {
                    error("Could not update the course module with the correct section");
                }

                if (!isset($mod->visible)) {   // We get the section's visible field status
                    $mod->visible = get_field("course_sections","visible","id",$sectionid);
                }
                // make sure visibility is set correctly (in particular in calendar)
                set_coursemodule_visible($mod->coursemodule, $mod->visible);

                if (isset($mod->redirect)) {
                    $SESSION->returnpage = $mod->redirecturl;
                } else {
                    $SESSION->returnpage = "$CFG->wwwroot/mod/$mod->modulename/view.php?id=$mod->coursemodule";
                }

                add_to_log($course->id, "course", "add mod",
                           "../mod/$mod->modulename/view.php?id=$mod->coursemodule",
                           "$mod->modulename $mod->instance");
                add_to_log($course->id, $mod->modulename, "add",
                           "view.php?id=$mod->coursemodule",
                           "$mod->instance", $mod->coursemodule);
                break;

            case "delete":
                $treeary = explode(":", $_POST["modid"]);
                $mk = max(array_keys($treeary));
                $cmid = $treeary[$mk];
                $resid = get_field_select("course_modules", "instance", "id='".$cmid."'");
		$res = get_record("resource", "id", $resid);
		$res->alltext = htmlspecialchars_decode($res->alltext, ENT_QUOTES);
		$alltextary = explode("<!-- id -->", $res->alltext);
		$idsary = explode(":", $alltextary[1]);
		$modid = $mod->delid;
                $newtext = $alltextary[0]."<!-- id -->";
		foreach ($idsary as $id) {
		    if (trim($id) != trim($modid) && !trim($id) == "") {
			$newtext .= $id.":";
		    }
		}
		$res->alltext = $newtext;
                if (! update_record("resource", $res)) {
		    notify("Could not edit the $mod->modulename(instance)");
		}
                if (! $deleteinstancefunction($mod->instance)) {
                    notify("Could not delete the $mod->modulename (instance)");
                }
                if (! delete_course_module($mod->coursemodule)) {
                    notify("Could not delete the $mod->modulename (coursemodule)");
                }
                if (! delete_mod_from_section($mod->coursemodule, "$mod->section")) {
                    notify("Could not delete the $mod->modulename from that section");
                }

                unset($SESSION->returnpage);

                add_to_log($course->id, "course", "delete mod",
                           "view.php?id=$mod->course",
                           "$mod->modulename $mod->instance", $mod->coursemodule);
		if (count($treeary) > 1) {
		    unset($treeary[$mk]);
		    $treeid = implode(":", $treeary);
	            return redirect("$CFG->wwwroot/course/mod2.php?id=".$mod->course."&amp;section=".$mod->section."&amp;sesskey=".
		    $_POST['sesskey']."&amp;update=".$cmid."&amp;type=tree&amp;treeid=".$treeid);
		} else {
	            return redirect("$CFG->wwwroot/course/mod2.php?id=".$mod->course."&amp;section=".$mod->section."&amp;sesskey=".
		    $_POST['sesskey']."&amp;update=".$cmid."&amp;type=tree&amp;treeid=".$treeid);
		}
                break;
            default:
                error("No mode defined");

        }

        rebuild_course_cache($course->id);

        if (!empty($SESSION->returnpage)) {
            $return = $SESSION->returnpage;
            unset($SESSION->returnpage);
            redirect($return);
        } else {
            redirect("view.php?id=$course->id#section-$sectionreturn");
        }
        exit;
    }

    if ((!empty($movetosection) or !empty($moveto)) and confirm_sesskey()) {
        if (! $movetosection == 0) {
	    $movetosection = $movetosection == -1 ? 0 : $movetosection;
            if (! $editcm = get_record("course_modules", "id", $_GET['movers'])) {
                error("The destination course module doesn't exist");
	    }
	    if (! $editrs = get_record("resource", "id", $editcm->instance))  {
	    	error("The destination resource doesn't exist");
	    }
	    $editalltext = explode("<!-- id -->", $editrs->alltext);
	    $idsary = explode(":", $editalltext[1]);
	    $alltext = $editalltext[0]."<!-- id -->\n";

	    foreach ($idsary as $key => $val) {
	        if ($val != trim($_GET['cmid'])) {
		    if ($key == trim($movetosection)) {
		        $alltext .= trim($_GET['cmid']).":".trim($val).":";
		    } elseif (!trim($val) == "") {
		       $alltext .= trim($val).":";
		    }
		}
	    }
	    $editrs->alltext = $alltext;

	    if (! update_record("resource", $editrs)) {
	        error("The resouce dosen't update");
	    } else {
	        $treeid = $USER->treeval;
                unset($USER->activitycopy);
                unset($USER->activitycopycourse);
                unset($USER->activitycopyname);
                unset($USER->treeval);
	        if (! trim($_GET['treeval']) == "1") {
	    	    redirect($CFG->wwwroot."/course/mod.php?update=".$editcm->id."&amp;sesskey=".$_GET['sesskey']."&amp;sr=&amp;treeid=$treeid");
		} else {
	    	    redirect($CFG->wwwroot."/course/mod2.php?update=".$editcm->id."&amp;sesskey=".$_GET['sesskey']."&amp;sr=treeid=$treeid");
		}
	    }
	    

        }

    } else if (!empty($indent) and confirm_sesskey()) {

        $id = required_param('id',PARAM_INT);

        if (! $cm = get_record("course_modules", "id", $id)) {
            error("This course module doesn't exist");
        }

        require_login($cm->course); // needed to setup proper $COURSE
        $context = get_context_instance(CONTEXT_COURSE, $cm->course);
        require_capability('moodle/course:manageactivities', $context);

        $cm->indent += $indent;

        if ($cm->indent < 0) {
            $cm->indent = 0;
        }

        if (!set_field("course_modules", "indent", $cm->indent, "id", $cm->id)) {
            error("Could not update the indent level on that course module");
        }

        if (SITEID == $cm->course) {
            redirect($CFG->wwwroot);
        } else {
            redirect("view.php?id=$cm->course#section-$sectionreturn");
        }
        exit;

    } else if (!empty($hide) and confirm_sesskey()) {

        if (! $cm = get_record("course_modules", "id", $hide)) {
            error("This course module doesn't exist");
        }

        require_login($cm->course); // needed to setup proper $COURSE
        $context = get_context_instance(CONTEXT_COURSE, $cm->course);
        require_capability('moodle/course:activityvisibility', $context);

        set_coursemodule_visible($cm->id, 0);

        rebuild_course_cache($cm->course);

        if (SITEID == $cm->course) {
            redirect($CFG->wwwroot);
        } else {
	    if (!trim($_GET['rntype']) == 1) {
	        redirect($CFG->wwwroot."/course/mod.php?update=".$treereturn."&sesskey=".$USER->sesskey."&sr=".$cm->section);
	    } else {
	        redirect($CFG->wwwroot."/course/mod2.php?update=".$treereturn."&sesskey=".$USER->sesskey."&sr=".$cm->section);
	    }
        }
        exit;

    } else if (!empty($show) and confirm_sesskey()) {

        if (! $cm = get_record("course_modules", "id", $show)) {
            error("This course module doesn't exist");
        }

        require_login($cm->course); // needed to setup proper $COURSE
        $context = get_context_instance(CONTEXT_COURSE, $cm->course);
        require_capability('moodle/course:activityvisibility', $context);

        if (! $section = get_record("course_sections", "id", $cm->section)) {
            error("This module doesn't exist");
        }

        if (! $module = get_record("modules", "id", $cm->module)) {
            error("This module doesn't exist");
        }

        if ($module->visible and ($section->visible or (SITEID == $cm->course))) {
            set_coursemodule_visible($cm->id, 1);
            rebuild_course_cache($cm->course);
        }

        if (SITEID == $cm->course) {
            redirect($CFG->wwwroot);
        } else {
	    if (!trim($_GET['rntype']) == 1) {
	        redirect($CFG->wwwroot."/course/mod.php?update=".$treereturn."&sesskey=".$USER->sesskey."&sr=".$cm->section);
	    } else {
	        redirect($CFG->wwwroot."/course/mod2.php?update=".$treereturn."&sesskey=".$USER->sesskey."&sr=".$cm->section);
	    }
        }
        exit;

    } else if ($groupmode > -1 and confirm_sesskey()) {

        $id = required_param( 'id', PARAM_INT );

        if (! $cm = get_record("course_modules", "id", $id)) {
            error("This course module doesn't exist");
        }

        require_login($cm->course); // needed to setup proper $COURSE
        $context = get_context_instance(CONTEXT_COURSE, $cm->course);
        require_capability('moodle/course:manageactivities', $context);

        set_coursemodule_groupmode($cm->id, $groupmode);

        rebuild_course_cache($cm->course);

        if (SITEID == $cm->course) {
            redirect($CFG->wwwroot);
        } else {
            redirect("view.php?id=$cm->course#section-$sectionreturn");
        }
        exit;

    } else if (!empty($copy) and confirm_sesskey()) { // value = course module

        if (! $cm = get_record("course_modules", "id", $copy)) {
            error("This course module doesn't exist");
        }

        require_login($cm->course); // needed to setup proper $COURSE
        $context = get_context_instance(CONTEXT_COURSE, $cm->course);
        require_capability('moodle/course:manageactivities', $context);

        if (! $section = get_record("course_sections", "id", $cm->section)) {
            error("This module doesn't exist");
        }

        if (! $module = get_record("modules", "id", $cm->module)) {
            error("This module doesn't exist");
        }

        if (! $instance = get_record($module->name, "id", $cm->instance)) {
            error("Could not find the instance of this module");
        }

        $USER->activitycopy = $copy;
        $USER->activitycopycourse = $cm->course;
        $USER->activitycopyname = $instance->name;
	$USER->treeval = $_GET['treeval'];

	redirect("$CFG->wwwroot/course/mod2.php?update=".$_GET['editid']."&amp;cmid=$copy&amp;sesskey=$USER->sesskey&amp;sr=$cm->section&amp;treeval=$USER->treeval");
    } else if (!empty($cancelcopy) and confirm_sesskey()) { // value = course module

        $courseid = $USER->activitycopycourse;

        unset($USER->activitycopy);
        unset($USER->activitycopycourse);
        unset($USER->activitycopyname);

        redirect("view.php?id=$courseid#section-$sectionreturn");

    } else if (!empty($delete) and confirm_sesskey()) {   // value = course module

        if (! $cm = get_record("course_modules", "id", $delete)) {
            error("This course module doesn't exist");
        }

        if (! $course = get_record("course", "id", $cm->course)) {
            error("This course doesn't exist");
        }

        require_login($cm->course); // needed to setup proper $COURSE
        $context = get_context_instance(CONTEXT_COURSE, $cm->course);
        require_capability('moodle/course:manageactivities', $context);
        
        if (! $module = get_record("modules", "id", $cm->module)) {
            error("This module doesn't exist");
        }

        if (! $instance = get_record($module->name, "id", $cm->instance)) {
            // Delete this module from the course right away
            if (! delete_mod_from_section($cm->id, $cm->section)) {
                notify("Could not delete the $module->name from that section");
            }
            if (! delete_course_module($cm->id)) {
                notify("Could not delete the $module->name (coursemodule)");
            }
            error("The required instance of this module didn't exist.  Module deleted.",
                  "$CFG->wwwroot/course/view.php?id=$course->id");
        }

        $fullmodulename = get_string("modulename", $module->name);

        $form->coursemodule = $cm->id;
        $form->section      = $cm->section;
        $form->course       = $cm->course;
        $form->instance     = $cm->instance;
        $form->modulename   = $module->name;
        $form->fullmodulename  = $fullmodulename;
        $form->instancename = $instance->name;
        $form->sesskey      = !empty($USER->id) ? $USER->sesskey : '';

        $strdeletecheck = get_string('deletecheck', '', $form->fullmodulename);
        $strdeletecheckfull = get_string('deletecheckfull', '', "$form->fullmodulename '$form->instancename'");

        $CFG->pagepath = 'mod/'.$module->name.'/delete';

        print_header_simple($strdeletecheck, '', $strdeletecheck);

        print_simple_box_start('center', '60%', '#FFAAAA', 20, 'noticebox');
        print_heading($strdeletecheckfull);
        include_once('../mod/resource/type/tree/mod_delete.html');
        print_simple_box_end();
        print_footer($course);

        exit;


    } else if (!empty($update) and confirm_sesskey()) {   // value = course module

        if (! $cm = get_record("course_modules", "id", $update)) {
            error("This course module doesn't exist");
        }

        if (! $course = get_record("course", "id", $cm->course)) {
            error("This course doesn't exist");
        }

        require_login($course->id); // needed to setup proper $COURSE
        $context = get_context_instance(CONTEXT_COURSE, $course->id);
        require_capability('moodle/course:manageactivities', $context);

        if (! $module = get_record("modules", "id", $cm->module)) {
            error("This module doesn't exist");
        }

        if (! $form = get_record($module->name, "id", $cm->instance)) {
            error("The required instance of this module doesn't exist");
        }

        if (! $cw = get_record("course_sections", "id", $cm->section)) {
            error("This course section doesn't exist");
        }

        if (isset($return)) {
            $SESSION->returnpage = "$CFG->wwwroot/mod/$module->name/view.php?id=$cm->id";
        }

        $form->coursemodule = $cm->id;
        $form->section      = $cm->section;     // The section ID
        $form->course       = $course->id;
        $form->module       = $module->id;
        $form->modulename   = $module->name;
        $form->instance     = $cm->instance;
        $form->mode         = "update";
        $form->sesskey      = !empty($USER->id) ? $USER->sesskey : '';

        $sectionname    = get_string("name$course->format");
        $fullmodulename = get_string("modulename", $module->name);

        if ($form->section && $course->format != 'site') {
            $heading->what = $fullmodulename;
            $heading->in   = "$sectionname $cw->section";
            $pageheading = get_string("updatingain", "moodle", $heading);
        } else {
            $pageheading = get_string("updatinga", "moodle", $fullmodulename);
        }
        $strnav = "<a href=\"$CFG->wwwroot/mod/$module->name/view.php?id=$cm->id\">".format_string($form->name,true)."</a> ->";
        
        if ($module->name == 'resource') {
            $CFG->pagepath = 'mod/'.$module->name.'/'.$form->type;
        } else {
            $CFG->pagepath = 'mod/'.$module->name.'/mod';
        }

    } else if (!empty($duplicate) and confirm_sesskey()) {   // value = course module


        if (! $cm = get_record("course_modules", "id", $duplicate)) {
            error("This course module doesn't exist");
        }

        if (! $course = get_record("course", "id", $cm->course)) {
            error("This course doesn't exist");
        }

        require_login($course->id); // needed to setup proper $COURSE
        $context = get_context_instance(CONTEXT_COURSE, $course->id);
        require_capability('moodle/course:manageactivities', $context);
        
        if (! $module = get_record("modules", "id", $cm->module)) {
            error("This module doesn't exist");
        }

        if (! $form = get_record($module->name, "id", $cm->instance)) {
            error("The required instance of this module doesn't exist");
        }

        if (! $cw = get_record("course_sections", "id", $cm->section)) {
            error("This course section doesn't exist");
        }

        if (isset($return)) {
            $SESSION->returnpage = "$CFG->wwwroot/mod/$module->name/view.php?id=$cm->id";
        }

        $section = get_field('course_sections', 'section', 'id', $cm->section);

        $form->coursemodule = $cm->id;
        $form->section      = $section;     // The section ID
        $form->course       = $course->id;
        $form->module       = $module->id;
        $form->modulename   = $module->name;
        $form->instance     = $cm->instance;
        $form->mode         = "add";
        $form->sesskey      = !empty($USER->id) ? $USER->sesskey : '';

        $sectionname    = get_string("name$course->format");
        $fullmodulename = get_string("modulename", $module->name);

        if ($form->section) {
            $heading->what = $fullmodulename;
            $heading->in   = "$sectionname $cw->section";
            $pageheading = get_string("duplicatingain", "moodle", $heading);
        } else {
            $pageheading = get_string("duplicatinga", "moodle", $fullmodulename);
        }
        $strnav = "<a href=\"$CFG->wwwroot/mod/$module->name/view.php?id=$cm->id\">$form->name</a> ->";

        $CFG->pagepath = 'mod/'.$module->name.'/mod';


    } else if (!empty($add) and confirm_sesskey()) {

        $id = required_param('id',PARAM_INT);
        $section = required_param('section',PARAM_INT);

        if (! $course = get_record("course", "id", $id)) {
            error("This course doesn't exist");
        }

        if (! $module = get_record("modules", "name", $add)) {
            error("This module type doesn't exist");
        }
        
        $context = get_context_instance(CONTEXT_COURSE, $course->id);
        require_capability('moodle/course:manageactivities', $context);
        
        if (!course_allowed_module($course,$module->id)) {
            error("This module has been disabled for this particular course");
        }

        require_login($course->id); // needed to setup proper $COURSE

        $form->section    = $section;         // The section number itself
        $form->course     = $course->id;
        $form->module     = $module->id;
        $form->modulename = $module->name;
        $form->instance   = "";
        $form->coursemodule = "";
        $form->mode       = "add";
        $form->sesskey    = !empty($USER->id) ? $USER->sesskey : '';
        if (!empty($type)) {
            $form->type = $type;
        }

        $sectionname    = get_string("name$course->format");
        $fullmodulename = get_string("modulename", $module->name);

        if ($form->section && $course->format != 'site') {
            $heading->what = $fullmodulename;
            $heading->to   = "$sectionname $form->section";
            $pageheading = get_string("addinganewto", "moodle", $heading);
        } else {
            $pageheading = get_string("addinganew", "moodle", $fullmodulename);
        }
        $strnav = '';

        $CFG->pagepath = 'mod/'.$module->name;
        if (!empty($type)) {
            $CFG->pagepath .= '/' . $type;
        }
        else {
            $CFG->pagepath .= '/mod';
        }

    } else {
        error("No action was specfied");
    }

    require_login($course->id); // needed to setup proper $COURSE
    $context = get_context_instance(CONTEXT_COURSE, $course->id);
    require_capability('moodle/course:manageactivities', $context);

    $streditinga = get_string("editinga", "moodle", $fullmodulename);
    $strmodulenameplural = get_string("modulenameplural", $module->name);

    if ($module->name == "label") {
        $focuscursor = "form.content";
    } else {
        $focuscursor = "form.name";
    }

    if ((!trim(@$_GET['treeid']) == "") && isset($_GET['bk'])) {
        $treeid = $_GET['treeid'];
    } elseif (trim(@$_GET['treeid']) == "") {
        @$treeid = $_GET['id'];
    } else {
        @$treeid = $_GET['treeid'].":".$_GET['id'];
    }
    $pos = strpos($treeid, ":");
    if (!$pos === FALSE) {
        $treeidary = explode(":", $treeid);
	$i = 1;
	$num = count($treeidary);
	@$sesskey = $_GET['sesskey'];
	foreach ($treeidary as $cmid) {
	    if (!trim($cmid) == "") {
	        unset($cm, $rs);
	        @$cm = get_record('course_modules', 'id', trim($cmid));
		@$rs = get_record('resource', 'id', $cm->instance);
		if ($i == 1) {
		    $tidary[] = $cmid;
		    @$navigationstr .= "<a href=\"$CFG->wwwroot/course/mod.php?update=$cmid&amp;sesskey=$sesskey\">$rs->name</a> ->";

		} elseif($num > $i) {
		    $tidstr = implode(":", $tidary);
		   @$navigationstr .= "<a href=\"$CFG->wwwroot/course/mod2.php?update=$cmid&amp;treeid=$tidstr&amp;sesskey=$sesskey\">$rs->name</a> ->";
		   $tidary[] = $cmid;
		}
	    }
	    $i++;
	}
    }

    if (empty($navigationstr)) {
        @$navigationstr = '&nbsp;';
    }
    print_header_simple('', '',
     "<a href=\"$CFG->wwwroot/mod/$module->name/index.php?id=$course->id\">$strmodulenameplural</a> ->$navigationstr $streditinga"
     , "", "", false);


    if (!empty($cm->id)) {
        $context = get_context_instance(CONTEXT_MODULE, $cm->id);
        $currenttab = 'update';
        include_once($CFG->dirroot.'/'.$CFG->admin.'/roles/tabs.php');
    }

    unset($SESSION->modform); // Clear any old ones that may be hanging around.

    $modform = "../mod/resource/type/tree/mod.html";

    if (file_exists($modform)) {

        if ($usehtmleditor = can_use_html_editor()) {
            $defaultformat = FORMAT_HTML;
            $editorfields = '';
        } else {
            $defaultformat = FORMAT_MOODLE;
        }

        $icon = '<img align="middle" height="16" width="16" src="'.$CFG->modpixpath.'/'.$module->name.'/icon.gif" alt="" style="vertical-align: middle;" />&nbsp;';

        print_heading_with_help($pageheading, "mods", $module->name, $icon);
        print_simple_box_start('center', '', '', 5, 'generalbox', $module->name);
        include_once($modform);
        print_simple_box_end();

        if ($usehtmleditor and empty($nohtmleditorneeded)) {
            use_html_editor($editorfields);
        }

    } else {
        notice("This module cannot be added to this course yet! (No file found at: $modform)", "$CFG->wwwroot/course/view.php?id=$course->id");
    }

    print_footer($course);
?>
