<?php // $Id: resource.class.php,v 1.25.4.1 2009/02/03 18:30:28 eLS $

class resource_tree extends resource_base {

	function resource_tree($cmid=0) {
	    parent::resource_base($cmid);
	}
	
	function rebuild_course_cache($courseid=0) {
	// Rebuilds the cached list of course activities stored in the database
	// If a courseid is not specified, then all are rebuilt
	
	    if ($courseid) {
	        $select = "id = '$courseid'";
	    } else {
	        $select = "";
	    }
	
	    if ($courses = get_records_select("course", $select,'','id,fullname')) {
	        foreach ($courses as $course) {
	            $modinfo = serialize(get_array_of_activities($course->id));
	            if (!set_field("course", "modinfo", $modinfo, "id", $course->id)) {
	                notify("Could not cache module information for course '$course->fullname'!");
	            }
	        }
	    }
	}
	
	function add_mod_to_section($mod, $beforemod=NULL) {
	/// Given a full mod object with section and course already defined
	/// If $before is specified, then this is an existing ID which we
	/// will insert the new module before
	///
	/// Returns the course_sections ID where the mod is inserted
	
	    if ($section = get_record("course_sections", "course", "$mod->course", "section", "$mod->section")) {
	
	        $section->sequence = trim($section->sequence);
	
	        if (empty($section->sequence)) {
	            $newsequence = "$mod->coursemodule";
	
	        } else if ($beforemod) {
	            $modarray = explode(",", $section->sequence);
	
	            if ($key = array_keys ($modarray, $beforemod->id)) {
	                $insertarray = array($mod->id, $beforemod->id);
	                array_splice($modarray, $key[0], 1, $insertarray);
	                $newsequence = implode(",", $modarray);
	
	            } else {  // Just tack it on the end anyway
	                $newsequence = "$section->sequence,$mod->coursemodule";
	            }
	        } else {
	            $newsequence = "$section->sequence,$mod->coursemodule";
	        }
	
	        if (set_field("course_sections", "sequence", $newsequence, "id", $section->id)) {
	            return $section->id;     // Return course_sections ID that was used.
	        } else {
	            return 0;
	        }
	
	    } else {  // Insert a new record
	        $section->course = $mod->course;
	        $section->section = $mod->section;
	        $section->summary = "";
	        $section->sequence = $mod->coursemodule;
	        return insert_record("course_sections", $section);
	    }
	}
	
	function add_instance($resource) {
	// Given an object containing all the necessary data, 
	// (defined by the form in mod.html) this function 
	// will create a new instance and return the id number 
	// of the new instance.
	
	    global $RESOURCE_WINDOW_OPTIONS, $CFG;
	
	    $resource->timemodified = time();
	    if (isset($resource->windowpopup)) {
	        $optionlist = array();
	        foreach ($RESOURCE_WINDOW_OPTIONS as $option) {
	            if (isset($resource->$option)) {
	                $optionlist[] = $option."=".$resource->$option;
	            }
	        }
	        $resource->popup = implode(',', $optionlist);
	
	    } else if (isset($resource->windowpage)) {
	        $resource->popup = "";
	    }
	
	    if (isset($resource->blockdisplay)) {
	        $resource->options = 'showblocks';
	    } else {
	        $resource->options = '';
	    }
	
	    if (isset($resource->parametersettingspref)) {
	        set_user_preference('resource_parametersettingspref', $resource->parametersettingspref);
	    }
	    if (isset($resource->windowsettingspref)) {
	        set_user_preference('resource_windowsettingspref', $resource->windowsettingspref);
	    }
	
	    if (isset($resource->addlink)) {
	        $addnum = array_keys($resource->addlink);
		
			$alltext = "";
	        if(strstr($resource->alltext[0], "<!-- id -->") === false) {
	            $resource->alltext[0] .= "\n<!-- id --><!-- set -->";
	            $alltext .= $resource->alltext[0];
		} else {
		    $idsstr = explode("<!-- id -->", $resource->alltext[0]);
		    $idsstr = str_replace("::", ":", $idsstr[1]);
		    $idsary = explode(":", $idsstr[1]);
		    foreach ($idsary as $key => $val) {
		        if (isset($addnum[$key])) {
		            $alltext .= $val."<!-- set -->:";
		        } else {
					if (!trim($val) == "") {
						$cmo = get_record("course_modules", "id", trim($val));
			       		$reso = get_record("resource", "id", $cmo->instance);
						if (trim($reso->name) == "") {
							$reso->alltext = $_POST["alltext[$key-1]"];
							$reso = quote_replace($reso);
						    if(!$chk = update_record("resource", $reso)){
								error('Update error1');
							}
						}
			    	}
			    	$alltext .= $val;
				}	
		    }
		}
	
		$resource->alltext = $alltext;
	    if(!$resource->instance = tree_insert_record($resource)){
	    	error("Getting instanceid missed.");
	    }
		$rootrsid = $resource->instance;
		$resource->added = $resource->timemodified;
		if (trim($_POST['section']) != "") {
		    $cms = get_record("course_sections", "course", $resource->course, "section", $_POST['section']);
		    $resource->section = $cms->id;
	        } else {
		    $rtcm = get_record("course_modules", "id", $_POST['id']);
		    $resource->section = $rtcm->section;
		    $cms = get_record("course_sections", "id", $resource->section);
		    $_POST['section'] = $cms->section;
		}
		unset($resource->id);
		if (isset($resource->treeid)) {
	        if(!$cld_id = insert_record("course_modules", $resource)){
				error('CM insert error');
			}
	        @$treeids = explode(":", $resource->treeid);
		    $tr_num = count($treeids);
		    $rt_cm = get_record("course_modules", "id", trim($treeids[$tr_num-1]));
		    $rt_rs = get_record("resource", "id", $rt_cm->instance);
		    $rt_rs->alltext = str_replace('<!-- set -->', $cld_id, $rt_rs->alltext);
		    if(!$chk = update_record("resource", $rt_rs)){
				error('Update error2');
			}
		    $treeid = $resource->treeid.":".$cld_id;
		} else {
		    if(!$treeid = insert_record("course_modules", $resource)){
				error('CM insert error');
			}
			$resource->coursemodule = $treeid;
			$mod = $resource;
			$mod->id = $mod->section;
		    $mod->section = $_POST['section'];
			add_mod_to_section($mod);
			rebuild_course_cache($resource->course);
		}
	
	        return redirect("$CFG->wwwroot/course/mod2.php?id=".$resource->course."&amp;section=".$_POST['section']."&amp;sesskey=".$resource->sesskey."&amp;add=resource&amp;type=tree&amp;treeid=".$treeid);
	
	    } elseif (isset($resource->treeid) && !isset($resource->addtext)) {
			$alltext = "";
	        if(strstr($resource->alltext[0], "<!-- id -->") === false) {
	            $resource->alltext[0] .= "<!-- id -->";
	            $alltext = $resource->alltext[0];
			} else {
			    $alltextary = explode("<!-- id -->", $resource->alltext);
			    $idsary = explode(":", str_replace("::", ":", $alltextary[1]));
			    $treetext = $_POST["alltext"];
			    foreach ($idsary as $key => $val) {
			        @$cmo = get_record("course_modules", "id", trim($val));
					@$reso = get_record("resource", "id", $cmo->instance);
			        if ($key = $addnum) {
			            $alltext .= $val."<!-- set -->:";
		            } elseif (trim($reso->name) == "") {
				    	$reso->alltext = $reetext[$key+1];
						if(!$chk = update_record("resource", $reso)){
							error('Update error3');
						}
			        } else {
				    	$alltext .= $val;
					}
		    	}
			}
			$resource->alltext = $alltext;
		    if(!$resource->instance = tree_insert_record($resource)){
		    	error("Getting instanceid missed.");
	    	}
			$resource->added = $resource->timemodified;
			$cms = get_record("course_sections", "course", $resource->course, "section", $resource->section);
			$resource->section = $cms->id;
			unset($resource->id);
			if(!$resid = insert_record("course_modules", $resource)){
				error('CM insert error');
			}
		    $treeid = $resource->treeid;
			$treeidary = explode(":", $treeid);
			if (count($treeidary) > 1) { 
			    $updateid = array_pop($treeidary);
			    $cm = get_record("course_modules", "id", $updateid);
			    $res = get_record("resource", "id", $cm->instance);
				$res = quote_decode($res);
			    $res->alltext = str_replace("<!-- set -->", $resid.":", $res->alltext);
			    $res->alltext = str_replace("::", ":", $res->alltext);
				$res = quote_replace($res);
			    if(!$chk = update_record("resource", $res)){
					error('Update error4');
				}
				$treeid = implode(":", $treeidary);
			    return redirect("$CFG->wwwroot/course/mod2.php?id=".$resource->course."&amp;section=".$_GET['section']."&amp;sesskey=".$resource->sesskey."&amp;update=".$updateid."&amp;type=tree&amp;treeid=".$treeid);
			} else {
			    $cm = get_record("course_modules", "id", $treeidary[0]);
			    $res = get_record("resource", "id", $cm->instance);
				$res = quote_decode($res);
			    $res->alltext = str_replace("<!-- set -->", $resid.":", $res->alltext);
			    $res->alltext = str_replace("::", ":", $res->alltext);
				$res = quote_replace($res);
			    if(!$chk = update_record("resource", $res)){
					error('Update error5');
				}
				return redirect("$CFG->wwwroot/course/mod.php?id=".$resource->course."&amp;section=".$_GET['section']."&amp;sesskey=".$resource->sesskey."&amp;update=".$resource->treeid."&amp;type=tree&amp;treeid=".$instance);
			}
	    } elseif (isset($resource->addtext)) { 
	        $resource->alltext = $resource->alltext[0]."<!-- id --><!-- set -->";
		    if(!$resource->instance = tree_insert_record($resource)){
		    	error("Getting instanceid missed.");
		    }
			$resource->added = $resource->timemodified;
			$cms = get_record("course_sections", "course", $resource->course, "section", $resource->section);
			$resource->section = $cms->id;
	
			unset($resource->id);
			if(!$resid = insert_record("course_modules", $resource)){
				error('CM insert error');
			}
			$resource->coursemodule = $resid;
			$resource->id = $resource->section;
			$resource->section = $_POST['section'];
			if (trim($resource->treeid) == "" || !isset($resource->treeid)) {
			    add_mod_to_section($resource);
			    rebuild_course_cache($resource->course);
			}
			$rs = get_record("resource", "id", $resource->instance);
			$id = $rs->id;
			$rs = quote_decode($rs);
			$alltext = $rs->alltext;
			$addrs = clone($rs);
			unset($addrs->reference, $addrs->summary, $addrs->alltext, $addrs->popup, $addrs->name);
			if(!$addcmid = tree_insert_record($addrs)){
				error('Resource insert error');
			}
			$addcm = $resource;
			$addcm->instance = $addcmid;
			$addcm->section = $cms->id;
			if(!$rsid = insert_record("course_modules", $addcm)){
				error('CM insert error');
			}
			$alltext = str_replace("<!-- set -->", $rsid.":", $alltext);
			$alltext = str_replace("::", ":", $alltext);
			$rs->alltext = $alltext;
			$rs = quote_replace($rs);
			$rs->id = $id;
			if(!$chk = update_record("resource", $rs)){
				error('Update error6');
			}
			if (!trim($resource->treeid) == "" || isset($resource->treeid)) {
		            return redirect("$CFG->wwwroot/course/mod2.php?id=".$resource->course."&amp;section=".$_GET['section']."&amp;sesskey=".$resource->sesskey."&amp;update=".$resid."&amp;type=tree&amp;treeid=".$resource->treeid);
			} else {
		            return redirect("$CFG->wwwroot/course/mod.php?id=".$resource->course."&amp;section=".$_GET['section']."&amp;sesskey=".$resource->sesskey."&amp;update=".$resid);
			}
	    } else {
	        $alltext = $resource->alltext[0];
			$resource->alltext = $alltext;
	        return insert_record("resource", $resource);
	    }
	}
	
	
	function update_instance($resource) {
	// Given an object containing all the necessary data, 
	// (defined by the form in mod.html) this function 
	// will update an existing instance with new data.
	
	    global $RESOURCE_WINDOW_OPTIONS, $CFG;
	
	    $resource->id = $resource->instance;
	    $resource->timemodified = time();
	
	    if (isset($resource->windowpopup)) {
	        $optionlist = array();
	        foreach ($RESOURCE_WINDOW_OPTIONS as $option) {
	            if (isset($resource->$option)) {
	                $optionlist[] = $option."=".$resource->$option;
	            }
	        }
	        $resource->popup = implode(',', $optionlist);
	
	    } else if (isset($resource->windowpage)) {
	        $resource->popup = "";
	    }
	
	    if (isset($resource->blockdisplay)) {
	        $resource->options = 'showblocks';
	    } else {
	        $resource->options = '';
	    }
	
	    if (isset($resource->parametersettingspref)) {
	        set_user_preference('resource_parametersettingspref', $resource->parametersettingspref);
	    }
	    if (isset($resource->windowsettingspref)) {
	        set_user_preference('resource_windowsettingspref', $resource->windowsettingspref);
	    }
	
	    if (trim($_GET['section']) == "") {
			$rtcm = get_record("course_modules", "instance", $resource->id);
			$cms = get_record("course_sections", "id", $rtcm->section);
			$_GET['section'] = $cms->section;
	    }
	
	    $alltext = "";
	    $res = get_record("resource", "id", $resource->id);
	    $res = quote_decode($res);
	    $alltextary = explode("<!-- id -->", $res->alltext);
	    $alltextary[1] = str_replace('<!-- set -->:', '', $alltextary[1]);
	    $alltextary[1] = str_replace('<!-- set -->', '', $alltextary[1]);
	    $idsary = explode(":", $alltextary[1]);
	    foreach ($idsary as $val) {
	        if (!trim($val) == "") {
		    	$idary2[] = $val;
			}
	    }
	    $idsary = $idary2;
	    $alltext = $resource->alltext[0]."<!-- id -->";
	    $alltext .= isset($resource->addlink[0]) ? ":<!-- set -->:" : "";
	    $treetext = $_POST["alltext"];
	    foreach ($idsary as $key => $value) {
	        if (!trim($value) == "") {
			    @$editcm = get_record("course_modules", "id", trim($value));
			    @$editrs = get_record("resource", "id", $editcm->instance);
			    @$editrs->alltext = $editrs->alltext;
			    if (! trim($editrs->name) == "") {
			        $alltext .= trim($value).":";
			        @$alltext .= trim($resource->addlink[$key+1]) != "" ? "<!-- set -->" : "";
			    } elseif (! trim($value) == "") {
			        $editrs->alltext = $treetext[$key+1];
			        $editrs = quote_replace($editrs);
				$editrs->timemodified = $editrs->timemodified+$key;
			        if(!$chk = update_record("resource", $editrs)){
						error('Update error7');
					}
			        $alltext .= $value.":";
			        if (isset($resource->addlink) && max(array_keys($resource->addlink)) == $key+1) {
			             $alltext .= "<!-- set -->";
			        }
			    }
			}
	    }
	    $resource->alltext = $alltext;
	    $resource = quote_replace($resource);
	    if (isset($resource->addlink)) {
	        if(!$chk = update_record("resource", $resource)){
				error('Update error8');
			}
			if (!$resource->treeid == "") {
			    $treeid = $resource->treeid.":".$resource->coursemodule;
			} else {
				$treeid = $resource->coursemodule;
			}
	        return redirect("$CFG->wwwroot/course/mod2.php?id=".$resource->course."&amp;section=".$_GET['section']."&amp;sesskey=".$resource->sesskey."&amp;add=resource&amp;type=tree&amp;treeid=".$treeid);
	    } elseif (isset($resource->addtext)) {
		$rs = get_record("resource", "id", $resource->instance);
		$cm = get_record("course_modules", "instance", $resource->instance);
		$id = $rs->id;
		$addrs = $rs;
		unset($addrs->reference, $addrs->summary, $addrs->alltext, $addrs->popup, $addrs->name);
		$addrs->timemodified = time();
		if(!$addcmid = tree_insert_record($addrs)){
			error('Resource insert error');
		}
		$addcm = $resource;
		$addcm->instance = $addcmid;
		$addcm->added = $rs->timemodified;
		$addcm->section = $cm->section;
		if(!$rsid = insert_record("course_modules", $addcm)){
			error('CM insert error');
		}
		$resource = quote_decode($resource);
		$alltextary = explode("<!-- id -->", $resource->alltext);
		$idsary = explode(":", $alltextary[1]);
		$alltext = $alltextary[0]."<!-- id -->";
		$textval = $_POST["alltext"];
		foreach ($idsary as $key => $val) { 
		    if (!trim($val) == "") {
			$cmo = get_record("course_modules", "id", trim($val));
			$rso = get_record("resource", "id", $cmo->instance);
			if (trim($rso->name) == "") {
	  		    $rso->alltext = $textval[$key+1];
		            $rso = quote_replace($rso);
			    if(!$chk = update_record("resource", $rso)){
					error('Update error9');
				}
			}
		        if (isset($resource->addtext[$key])) {
			    $alltext .= $rsid.":".$val.":";
			} else {
			        $alltext .= $val.":";
			}
		    } elseif (isset($resource->addtext[$key])) {
		          $alltext .= $rsid.":";
		    }
		}
		$rs->alltext = str_replace("::", ":", $alltext);
		$rs = quote_replace($rs);
		$rs->id = $id;
		$rs->name = $_POST["name"];
		if(!$chk = update_record("resource", $rs)){
			error('Update error10');
		}
	        $treeid = isset($resource->treeid) ? "&amp;treeid=$resource->treeid" : "";
	        return redirect("$CFG->wwwroot/course/mod2.php?id=".$resource->course."&amp;section=".$_GET['section']."&amp;sesskey=".$resource->sesskey."&amp;update=$resource->coursemodule".$treeid);
	    } elseif (isset($resource->treeid) && !isset($_GET['bk'])) {
			if(!$chk = update_record("resource", $resource)){
				error('Update error11');
			}
			$treecm = get_record("course_modules", "instance", $resource->id);
			$treeid = $resource->treeid;
			$treeidary = explode(":", $treeid);
			$treenum = count($treeidary);
			if (!$treenum == 0 && !$treeid == "") {
			    $updateid = array_pop($treeidary);
			    $treeid = implode(":", $treeidary);
				$cm = get_record("course_modules", "id", $updateid);
				$res = get_record("resource", "id", $cm->instance);
				$res = quote_decode($res);
			    $res->alltext = str_replace("<!-- set -->", $treecm->id.":", $res->alltext);
			    $res->alltext = str_replace("::", ":", $res->alltext);
				$res = quote_replace($res);
				if(!$chk = update_record("resource", $res)){
					error('Update error12');
				}
			    return redirect("$CFG->wwwroot/course/mod2.php?id=".$resource->course."&amp;section=".$_GET['section']."&amp;sesskey=".$resource->sesskey."&amp;update=".$updateid."&amp;type=tree&amp;treeid=".$treeid);
			} else {
			    return update_record("resource", $resource);
			}
	    } else {
	        $alltextary = explode("<!-- id -->", $resource->alltext);
			if (!trim($alltextary[1]) == "" ) {
			    @$idsary = explode(":", $alltextary[1]);
			    $treetext = $_POST["alltext"];
			    foreach ($idsary as $key => $val) {
			        if (! trim($val) == "") {
					    @$cmo = get_record("course_modules", "id", trim($val));
					    @$reso = get_record("resource", "id", $cmo->instance);
					    if (trim($reso->name) == "") {
					        $reso->alltext = $treetext[$key+1];
							if(!$chk = update_record("resource", $reso)){
								error('Update error13');
							}
					    }
					}
		    	}
	        }
			return update_record("resource", $resource);
	    }
	}
	
	function display() {
	    global $CFG;
        $inpopup_param = optional_param( 'inpopup','' );
        $inpopup = !empty($inpopup_param);
	    /// Are we displaying the course blocks?
	    if ((!trim(@$_GET['treeid']) == "") && isset($_GET['bk'])) {
	        $treeid = $_GET['treeid'];
	    } elseif (trim(@$_GET['treeid']) == "") {
	        $treeid = $_GET['id'];
	    } else {
	        $treeid = $_GET['treeid'].":".$_GET['id'];
	    }
	    $pos = strpos($treeid, ":");
	    if (!$pos === FALSE) {
	        $treeidary = explode(":", $treeid);
			$i = 1;
			$num = count($treeidary);
			$treenavi = "";
			foreach ($treeidary as $cmid) {
			    if (is_numeric($cmid)) {
			        $cm = get_record('course_modules', 'id', $cmid);
					$rs = get_record('resource', 'id', $cm->instance);
					if ($i == 1) {
					    $tidary[] = $cmid;
					    $treenavi .= "<a href=\"$CFG->wwwroot/mod/resource/view.php?id=$cmid\">$rs->name</a> ->";
						$back = "<div align=\"center\"><a href=\"$CFG->wwwroot/mod/resource/view.php?id=$cmid&amp;inpopup=$inpopup\">".get_string('parent','resource')."</a></div>";
					} elseif($num > $i) {
					    $tidary[] = $cmid;
					    $tidstr = implode(":", $tidary);
					    $treenavi .= "<a href=\"$CFG->wwwroot/mod/resource/view.php?id=$cmid&amp;treeid=$tidstr&amp;bk=1\">$rs->name</a> ->";
					    if($inpopup){
					    	$back = "<div align=\"center\"><a href=\"$CFG->wwwroot/mod/resource/view.php?id=$cmid&amp;treeid=$tidstr&amp;inpopup=true&amp;bk=1\">".get_string('parent','resource')."</a></div>";
					    }else{
					    	$back = "<div align=\"center\"><a href=\"$CFG->wwwroot/mod/resource/view.php?id=$cmid&amp;treeid=$tidstr&amp;bk=1\">".get_string('parent','resource')."</a></div>";
					    }
					}
			    }
			    $i++;
			}
	    }
	
	    if ($this->resource->options == 'showblocks') {
	        parent::display_course_blocks_start2();
	        $formatoptions->noclean = true;
	        $this->resource = quote_decode($this->resource);
	        $alltextary = explode("<!-- id -->", $this->resource->alltext);
	        if (count($alltextary) > 1) {
				if (!trim($alltextary[0]) == "") {
	                @$viewhtml = format_text($alltextary[0]."<br />", FORMAT_HTML, $formatoptions, $course->id);
	            } else {
	                @$viewhtml = format_text($alltextary[0], FORMAT_HTML, $formatoptions, $course->id);
		    	}
	            $idsary = explode(":", $alltextary[1]);
		 	    foreach ($idsary as $key => $val) {
			        if (is_numeric($val)) {
			            $cmo = get_record("course_modules", "id", trim($val));
				    $res = get_record("resource", "id", $cmo->instance);
				    if (! trim($res->name) == "" && trim($cmo->visible) == 1) {
				        if (trim($alltextary[0]) == "" && $key == 0) {
				            $atab = "<a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$cmo->id."&amp;treeid=".$treeid."'>".$res->name."</a><br />";
					} else {
				            $atab = "<br /><a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$cmo->id."&amp;treeid=".$treeid."'>".$res->name."</a><br />";
					}
				        $viewhtml .= format_text($atab, FORMAT_HTML, $formatoptions, $cmo->id);
				    } elseif (trim($cmo->visible) == 1) {
				        $res = quote_decode($res);
				        $alltext = explode("<!-- id -->", $res->alltext);
				        if (!is_null($alltext[0])) {
				    	    $viewhtml .= format_text("<br />".$alltext[0]."<br />", FORMAT_HTML, $formatoptions, $cmo->id);
				        }
				    }
		        }
		    }
	            echo format_text($viewhtml, FORMAT_HTML, $formatoptions, $this->course->id);
	        } else {
	            echo format_text($viewhtml, FORMAT_HTML, $formatoptions, $this->course->id);
	        }
	
	        parent::display_course_blocks_end();
	
	    } else {
	        /// Set up generic stuff first, including checking for access
	        parent::display();
	        /// Set up some shorthand variables
	        $cm = $this->cm;     
	        $course = $this->course;
	        $resource = $this->resource;
	        $pagetitle = strip_tags($course->shortname.': '.format_string($resource->name));
	        $formatoptions->noclean = true;
            if ($inpopup) {                    /// Popup only
                add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", $resource->id, $cm->id);
                print_header();
                echo "<br />".$back."<br />";
                $resource = quote_decode($resource);
                $alltextary = explode("<!-- id -->", $resource->alltext);
                if (count($alltextary) > 1) {
					if (!trim($alltextary[0]) == "") {
                        $viewhtml = format_text($alltextary[0]."<br />", FORMAT_HTML, $formatoptions, $course->id);
					} else {
                        $viewhtml = format_text($alltextary[0], FORMAT_HTML, $formatoptions, $course->id);
					}
	            	$idsary = explode(":", $alltextary[1]);
		   		    foreach ($idsary as $key => $val) {
				        if (is_numeric($val)) {
				            $cmo = get_record("course_modules", "id", trim($val));
					    	$res = get_record("resource", "id", $cmo->instance);
						    if (! trim($res->name) == "" && trim($cmo->visible) == 1) { 
								if(!$treeid){
									$treeid = $_GET["id"];
								}
								if(!$res->popup){
									if (trim($alltextary[0]) == "" && $key == 0) {
								            $atab = "<a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$cmo->id."&amp;treeid=".$treeid."&amp;inpopup=true'>".$res->name."</a><br />";
									} else {
								            $atab = "<br /><a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$cmo->id."&amp;treeid=".$treeid."&amp;inpopup=true'>".$res->name."</a><br />";
									}
								}else{
									if (trim($alltextary[0]) == "" && $key == 0) {
                							$atab = "<a href=\"$CFG->wwwroot/mod/resource/view.php?inpopup=true&amp;id=".$cmo->id."&amp;treeid=$treeid\" onclick=\"return openpopup('/mod/resource/view.php?inpopup=true&amp;id={$cmo->id}&amp;treeid={$treeid}', 'resource{$res->id}','{$res->popup}');\">".$res->name."</a>";
									} else {
                							$atab = "<br /><a href=\"$CFG->wwwroot/mod/resource/view.php?inpopup=true&amp;id=".$cmo->id."&amp;treeid=$treeid\" onclick=\"return openpopup('/mod/resource/view.php?inpopup=true&amp;id={$cmo->id}&amp;treeid={$treeid}', 'resource{$res->id}','{$res->popup}');\">".$res->name."</a>";
									}
								}
						        $viewhtml .= format_text($atab, FORMAT_HTML, $formatoptions, $cmo->id);
						    } elseif (trim($cmo->visible) == 1) {
						        $alltext = explode("<!-- id -->", $res->alltext);
						        if (!is_null($alltext[0])) {
						    	    $viewhtml .= format_text("<br />".$alltext[0]."<br />", FORMAT_HTML, $formatoptions, $cmo->id);
						        }
						    }
				        }
				    }
		    		print_simple_box($viewhtml, "center", "", "", "20");
				} else {
                    print_simple_box(format_text($resource->alltext, FORMAT_HTML, $formatoptions, $course->id), "center", "", "", "20");
	        	}
                print_footer($course);
			} elseif($resource->popup) {                           /// Make a page and a pop-up window
	            print_header($pagetitle, $course->fullname,  $this->navigation.$treenavi.format_string($resource->name),
	                    "", "", true, update_module_button($cm->id, $course->id, $this->strresource), 
	                    navmenu($course, $cm));
                echo "<br />".$back."<br />";
				@$treeid = $_GET["treeid"];
                echo "\n<script language=\"javascript\" type=\"text/javascript\">";
                echo "\n<!--\n";
                echo "openpopup('/mod/resource/view.php?inpopup=true&treeid={$treeid}&id={$cm->id}','resource{$resource->id}','{$resource->popup}');\n";
                //echo "openpopup('/mod/resource/view.php?inpopup=true&id={$cm->id}','resource{$resource->id}','{$resource->popup}');\n";
                echo "\n-->\n";
                echo '</script>';

                if (trim(strip_tags($resource->summary))) {
                    print_simple_box(format_text($resource->summary, FORMAT_MOODLE, $formatoptions, $course->id), "center");
                }

                @$treeid2 = $_GET['treeid'].":".$_GET['id'];
                $link = "<a href=\"$CFG->wwwroot/mod/resource/view.php?inpopup=true&amp;id={$cm->id}&amp;treeid=$treeid\" target=\"resource{$resource->id}\" onclick=\"return openpopup('/mod/resource/view.php?inpopup=true&amp;id={$cm->id}&amp;treeid={$treeid2}', 'resource{$resource->id}','{$resource->popup}');\">".format_string($resource->name,true)."</a>";
                //$link = "<a href=\"$CFG->wwwroot/mod/resource/view.php?inpopup=true&amp;id={$cm->id}\" target=\"resource{$resource->id}\" onclick=\"return openpopup('/mod/resource/view.php?inpopup=true&amp;id={$cm->id}', 'resource{$resource->id}','{$resource->popup}');\">".format_string($resource->name,true)."</a>";
                echo '<p align="center">';
                print_string('popupresource', 'resource');
                echo '<br />';
                print_string('popupresourcelink', 'resource', $link);
                echo "</p>";
                print_footer($course);
            }else{                      //not popup
	            add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", $resource->id, $cm->id);
	            print_header($pagetitle, $course->fullname,  $this->navigation.$treenavi.format_string($resource->name),
	                    "", "", true, update_module_button($cm->id, $course->id, $this->strresource), 
	                    navmenu($course, $cm));
	            echo "<br />".$back."<br />";
	            $resource = quote_decode($resource);
	            $alltextary = explode("<!-- id -->", $resource->alltext);
	            if (count($alltextary) > 1) {
			        if (!trim($alltextary[0]) == "") {
		                    $viewhtml = format_text($alltextary[0]."<br />", FORMAT_HTML, $formatoptions, $course->id);
			        } else {
		                    $viewhtml = format_text($alltextary[0], FORMAT_HTML, $formatoptions, $course->id);
					}
					$idsary = explode(":", $alltextary[1]);
					foreach ($idsary as $key => $val) {
			                    if (is_numeric($val)) {
					        $cmo = get_record("course_modules", "id", trim($val));
						$res = get_record("resource", "id", $cmo->instance);
						if (! trim($res->name) == "" && trim($cmo->visible) == 1) {
						    if (trim($alltextary[0]) == "" && $key == 0) {
						        $atab = "<a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$cmo->id."&amp;treeid=".$treeid."'>".$res->name."</a><br />";
						    } else {
						        $atab = "<br /><a href='".$CFG->wwwroot."/mod/resource/view.php?id=".$cmo->id."&amp;treeid=".$treeid."'>".$res->name."</a><br />";
						    }
						    $viewhtml .= format_text($atab, FORMAT_HTML, $formatoptions, $cmo->id);
						} elseif (trim($cmo->visible) == 1) {
						    $res = quote_decode($res);
						    $alltext = explode("<!-- id -->", $res->alltext);
						    if (!is_null($alltext[0])) {
						    	$viewhtml .= format_text("<br />".$alltext[0]."<br />", FORMAT_HTML, $formatoptions, $cmo->id);
						    }
						}
					    }
					
					}
					print_simple_box($viewhtml, "center", "", "", "20");
				
			    } else {
					print_simple_box(format_text($resource->alltext, FORMAT_HTML, $formatoptions, $course->id), "center", "", "", "20");
				}
	            $strlastmodified = get_string("lastmodified");
	            echo "<center><p><font size=\"1\">$strlastmodified: ".userdate($resource->timemodified)."</font></p></center>";
	            print_footer($course);
	        }
	
	    }
	
	}
	
	function setup($form) {
	    global $CFG, $usehtmleditor, $RESOURCE_WINDOW_OPTIONS;
	    
	    parent::setup($form);
	
	    $strfilename = get_string("filename", "resource");
	    $strnote     = get_string("note", "resource");
	    $strchooseafile = get_string("chooseafile", "resource");
	    $strnewwindow     = get_string("newwindow", "resource");
	    $strnewwindowopen = get_string("newwindowopen", "resource");
	    $strsearch        = get_string("searchweb", "resource");
	
	    foreach ($RESOURCE_WINDOW_OPTIONS as $optionname) {
	        $stringname = "str$optionname";
	        $$stringname = get_string("new$optionname", "resource");
	        $window->$optionname = "";
	        $jsoption[] = "\"$optionname\"";
	    }
	    
	    $blockoption = "\"blockdisplay\"";
	    $popupoptions = implode(",", $jsoption);
	    $jsoption[] = $blockoption;
	    $alloptions = implode(",", $jsoption);
	
	    if ($form->instance) {     // Re-editing
	        if (!$form->popup) {
	            $windowtype = "page";   // No popup text => in page
	            foreach ($RESOURCE_WINDOW_OPTIONS as $optionname) {
	                $defaultvalue = "resource_popup$optionname";
	                $window->$optionname = $CFG->$defaultvalue;
	            }
	        } else {
	            $windowtype = "popup";
	            $rawoptions = explode(',', $form->popup);
	            foreach ($rawoptions as $rawoption) {
	                $option = explode('=', trim($rawoption));
	                $optionname = $option[0];
	                $optionvalue = $option[1];
	                if ($optionname == "height" or $optionname == "width") {
	                    $window->$optionname = $optionvalue;
	                } else if ($optionvalue) {
	                    $window->$optionname = 'checked="checked"';
	                }
	            }
	        }
	    } else {
	        foreach ($RESOURCE_WINDOW_OPTIONS as $optionname) {
	            $defaultvalue = "resource_popup$optionname";
	
	            if ($optionname == "height" or $optionname == "width") {
	                $window->$optionname = $CFG->$defaultvalue;
	            } else if ($CFG->$defaultvalue) {
	                $window->$optionname = 'checked="checked"';
	            }
	        }
	
	        $windowtype = ($CFG->resource_popup) ? 'popup' : 'page';
	        if (!isset($form->options)) {
	            $form->options = '';
	        }
	    }
	    include("$CFG->dirroot/mod/resource/type/tree/html.html");
	
	    parent::setup_end();
	}
	
	function setup2($form) {
	    global $CFG, $usehtmleditor, $RESOURCE_WINDOW_OPTIONS;
	    
	    parent::setup2($form);
	
	    $strfilename = get_string("filename", "resource");
	    $strnote     = get_string("note", "resource");
	    $strchooseafile = get_string("chooseafile", "resource");
	    $strnewwindow     = get_string("newwindow", "resource");
	    $strnewwindowopen = get_string("newwindowopen", "resource");
	    $strsearch        = get_string("searchweb", "resource");
	
	    foreach ($RESOURCE_WINDOW_OPTIONS as $optionname) {
	        $stringname = "str$optionname";
	        $$stringname = get_string("new$optionname", "resource");
	        $window->$optionname = "";
	        $jsoption[] = "\"$optionname\"";
	    }
	    
	    $blockoption = "\"blockdisplay\"";
	    $popupoptions = implode(",", $jsoption);
	    $jsoption[] = $blockoption;
	    $alloptions = implode(",", $jsoption);
	
	    if ($form->instance) {     // Re-editing
	        if (!$form->popup) {
	            $windowtype = "page";   // No popup text => in page
	            foreach ($RESOURCE_WINDOW_OPTIONS as $optionname) {
	                $defaultvalue = "resource_popup$optionname";
	                $window->$optionname = $CFG->$defaultvalue;
	            }
	        } else {
	            $windowtype = "popup";
	            $rawoptions = explode(',', $form->popup);
	            foreach ($rawoptions as $rawoption) {
	                $option = explode('=', trim($rawoption));
	                $optionname = $option[0];
	                $optionvalue = $option[1];
	                if ($optionname == "height" or $optionname == "width") {
	                    $window->$optionname = $optionvalue;
	                } else if ($optionvalue) {
	                    $window->$optionname = 'checked="checked"';
	                }
	            }
	        }
	    } else {
	        foreach ($RESOURCE_WINDOW_OPTIONS as $optionname) {
	            $defaultvalue = "resource_popup$optionname";
	
	            if ($optionname == "height" or $optionname == "width") {
	                $window->$optionname = $CFG->$defaultvalue;
	            } else if ($CFG->$defaultvalue) {
	                $window->$optionname = 'checked="checked"';
	            }
	        }
	
	        $windowtype = 'page';
	        if (!isset($form->options)) {
	            $form->options = '';
	        }
	    }
	    include("$CFG->dirroot/mod/resource/type/tree/html.html");
	
	    parent::setup_end();
	}

}

function make_editing_buttons2($mod, $absolute=false, $moveselect=true, $indent=-1, $section=-1, $treenum, $treeval) {
    global $CFG, $USER;

    static $str;
    static $sesskey;

    if (!isset($str)) {
        $str->delete         = get_string("delete");
        $str->move           = get_string("move");
        $str->moveup         = get_string("moveup");
        $str->movedown       = get_string("movedown");
        $str->moveright      = get_string("moveright");
        $str->moveleft       = get_string("moveleft");
        $str->update         = get_string("update");
        $str->duplicate      = get_string("duplicate");
        $str->hide           = get_string("hide");
        $str->show           = get_string("show");
        $str->clicktochange  = get_string("clicktochange");
        $str->forcedmode     = get_string("forcedmode");
        $str->groupsnone     = get_string("groupsnone");
        $str->groupsseparate = get_string("groupsseparate");
        $str->groupsvisible  = get_string("groupsvisible");
        $sesskey = sesskey();
    }

    if ($section >= 0) {
        $section = '&amp;sr='.$section;   // Section return
    } else {
        $section = '';
    }

    if ($absolute) {
        $path = $CFG->wwwroot.'/course';
    } else {
        $path = '.';
    }

    if (isset($_GET["treeid"])) {
    	if (strpos($_GET["treeid"], $_GET["update"]) === false) {
	    $treeid = $_GET["treeid"].":".$_GET["update"];
	    $rntype = 1;
	} else {
	    $treeid = $_GET["treeid"];
	    $rntype = 1;
	}
    } else {
        $treeid = $_GET["update"];
        $rntype = 0;
    }

    if ($mod->visible) {
        $hideshow = '<a class="editing_hide" title="'.$str->hide.'" href="'.$path.'/mod2.php?hide='.$mod->id.
                    '&amp;sesskey='.$sesskey.$section.'&amp;rncid='.$_GET['update'].'&amp;rntype='.$rntype.'"><img'.
                    ' src="'.$CFG->pixpath.'/t/hide.gif" hspace="2" height="11" width="11" '.
                    ' border="0" alt="'.$str->hide.'" /></a>'."\n";
    } else {
        $hideshow = '<a class="editing_show" title="'.$str->show.'" href="'.$path.'/mod2.php?show='.$mod->id.
                    '&amp;sesskey='.$sesskey.$section.'&amp;rncid='.$_GET['update'].'&amp;rntype='.$rntype.'"><img'.
                    ' src="'.$CFG->pixpath.'/t/show.gif" hspace="2" height="11" width="11" '.
                    ' border="0" alt="'.$str->show.'" /></a>'."\n";
    }
    if ($mod->groupmode !== false) {
        if ($mod->groupmode == SEPARATEGROUPS) {
            $grouptitle = $str->groupsseparate;
            $groupclass = 'editing_groupseparate';
            $groupimage = $CFG->pixpath.'/t/groups.gif';
            $grouplink  = $path.'/mod.php?id='.$mod->id.'&amp;groupmode=0&amp;sesskey='.$sesskey;
        } else if ($mod->groupmode == VISIBLEGROUPS) {
            $grouptitle = $str->groupsvisible;
            $groupclass = 'editing_groupvisible';
            $groupimage = $CFG->pixpath.'/t/groupv.gif';
            $grouplink  = $path.'/mod.php?id='.$mod->id.'&amp;groupmode=1&amp;sesskey='.$sesskey;
        } else {
            $grouptitle = $str->groupsnone;
            $groupclass = 'editing_groupsnone';
            $groupimage = $CFG->pixpath.'/t/groupn.gif';
            $grouplink  = $path.'/mod.php?id='.$mod->id.'&amp;groupmode=2&amp;sesskey='.$sesskey;
        }

    if ($treenum > 2) {
        if ($moveselect) {
            $editid = $_GET['update'];
	    $treeval = trim($treeval) != "" ? "&amp;treeval=".$treeval : "";
            $move =     '<a class="editing_move" title="'.$str->move.'" href="'.$path.'/mod2.php?copy='.$mod->id.
                        '&amp;sesskey='.$sesskey.$section.'&amp;editid='.$editid.$treeval.'"><img'.
                        ' src="'.$CFG->pixpath.'/t/move.gif" hspace="2" height="11" width="11" '.
                        ' border="0" alt="'.$str->move.'" /></a>'."\n";
        } else {
            $move =     '';
        }
    } else {
        $move = "";
    }

    if ($mod->lowflg == "1") { 
        if (!trim(@$_GET["treeid"]) == "") {
	    $treeid = $_GET["treeid"].":".$_GET["update"];
	} else {
	    $treeid = $_GET["update"];
	}
	$delete_edit = '<a class="editing_delete" title="'.$str->delete.'" href="'.$path.'/mod2.php?delete='.$mod->id.
           '&amp;sesskey='.$sesskey.$section.'&amp;treeid='.$treeid.'"><img'.
           ' src="'.$CFG->pixpath.'/t/delete.gif" hspace="2" height="11" width="11" border="0" '.
           ' alt="'.$str->delete.'" />';
    } else {
		$delete_edit = "";
    }
    return '<span class="commands">'."\n".$move.
           '<a class="editing_update" title="'.$str->update.'" href="'.$path.'/mod2.php?update='.$mod->id.
           '&amp;sesskey='.$sesskey.$section.'&amp;treeid='.$treeid.'">'.
           '<img src="'.$CFG->pixpath.'/t/edit.gif" hspace="2" height="11" width="11" border="0" '.
           ' alt="'.$str->update.'" /></a>'."\n".$delete_edit."\n".$hideshow."\n".'</span>';
    }
}

function quote_replace($ary){
	$ary->name = str_replace("'","&#039;",$ary->name);
	$ary->alltext = str_replace("'","&#039;",$ary->alltext);
	return $ary;
}
function quote_decode($ary){
	$ary->name = htmlspecialchars_decode($ary->name, ENT_QUOTES);
	$ary->alltext = htmlspecialchars_decode($ary->alltext, ENT_QUOTES);
	return $ary;
}

function tree_insert_record($resource){
        if($resource->id){
                $insertdata->id = $resource->id;
        }
        $insertdata->course = $resource->course;
        if($resource->name){
                $insertdata->name = $resource->name;
        }else{
                $insertdata->name = "";
        }
        $insertdata->type = $resource->type;
        if($resource->reference){
                $insertdata->reference = $resource->reference;
        }else{
                $insertdata->reference = 0;
        }
        if($resource->summary){
                $insertdata->summary = $resource->summary;
        }else{
                $insertdata->summary = "";
        }
        if($resource->alltext){
                $insertdata->alltext = $resource->alltext;
        }else{
                $insertdata->alltext = "";
        }
        if($resource->popup){
                $insertdata->popup = $resource->popup;
        }else{
                $insertdata->popup = "";
        }
        $insertdata->options = $resource->options;
        $insertdata->timemodified = $resource->timemodified;
        $insertdata = quote_replace($insertdata);
    if(!$resource->instance = insert_record("resource", $insertdata)){
        error("Insert Error");
    }
    return $resource->instance;
}

?>